import React__default, { useContext } from 'react';
import { L as LocalizationContext } from '../../chunks/bundle-Dx_38OXn.js';
import MessageInput from '../../ui/MessageInput.js';
import { u as useOpenChannelContext } from '../../chunks/bundle-jrAqoPyl.js';
import '../../chunks/bundle-k5pprEL4.js';
import '../../chunks/bundle-DoyzmJ4N.js';
import '../../chunks/bundle-Dsv3ZewI.js';
import '../../chunks/bundle-JgyblkJN.js';
import '../../chunks/bundle-CGpoAabY.js';
import '../../ui/IconButton.js';
import '../../ui/Button.js';
import '../../chunks/bundle-DHMhzdxb.js';
import '../../chunks/bundle-D13EwQ7_.js';
import 'dompurify';
import '../../chunks/bundle-T9VvSLxm.js';
import '../../chunks/bundle-Bx8Sqjji.js';
import '../../chunks/bundle-DIah6iEu.js';
import '../../ui/Icon.js';
import '../../chunks/bundle-Ds9YPch2.js';
import '../../chunks/bundle-BKsKPtjg.js';
import '@sendbird/chat/groupChannel';
import '../../utils/message/getOutgoingMessageState.js';
import '../../chunks/bundle-DTJNwlmx.js';
import '../../chunks/bundle-CmS7TEQp.js';
import '../../chunks/bundle-Dhfbe9sC.js';
import '../../chunks/bundle-CAqNV7Jw.js';
import '../../chunks/bundle-CKuLtDzG.js';
import '../../chunks/bundle-DlIBbbMW.js';
import '../../chunks/bundle-3CHYtOfL.js';
import '@sendbird/chat';
import '@sendbird/chat/openChannel';
import '../../chunks/bundle-D6tIALJA.js';
import '../../chunks/bundle-dMfcSy1Y.js';
import '../../chunks/bundle-Bv2JmaC2.js';
import '../../chunks/bundle-Dub55x6v.js';
import '../../chunks/bundle-3CVJzoCD.js';
import '../../chunks/bundle-BCC98_OB.js';
import '../../hooks/useModal.js';
import '../../chunks/bundle-EGZmMlDM.js';
import 'react-dom';
import '../../chunks/bundle-CDtkDyUw.js';

var OpenChannelInput = React__default.forwardRef(function (props, ref) {
    var _a = useOpenChannelContext(), currentOpenChannel = _a.currentOpenChannel, disabled = _a.disabled, handleSendMessage = _a.handleSendMessage, handleFileUpload = _a.handleFileUpload, amIMuted = _a.amIMuted;
    var channel = currentOpenChannel;
    var stringSet = useContext(LocalizationContext).stringSet;
    var value = props.value;
    function getPlaceHolderString() {
        if (amIMuted) {
            return stringSet.MESSAGE_INPUT__PLACE_HOLDER__MUTED;
        }
        if (disabled) {
            return stringSet.MESSAGE_INPUT__PLACE_HOLDER__DISABLED;
        }
        return '';
    }
    if (!channel) {
        return null;
    }
    return (React__default.createElement("div", { className: "sendbird-openchannel-footer" },
        React__default.createElement(MessageInput, { channel: currentOpenChannel, ref: ref, value: value, disabled: disabled, isVoiceMessageEnabled: false, onSendMessage: handleSendMessage, onFileUpload: handleFileUpload, placeholder: getPlaceHolderString() })));
});

export { OpenChannelInput as default };
//# sourceMappingURL=OpenChannelInput.js.map
