import React__default from 'react';
import { u as useOpenChannelContext } from '../../chunks/bundle-jrAqoPyl.js';
import OpenChannelInput from './OpenChannelInput.js';
import FrozenNotification from './FrozenChannelNotification.js';
import OpenchannelConversationHeader from './OpenChannelHeader.js';
import PlaceHolder, { PlaceHolderTypes } from '../../ui/PlaceHolder.js';
import OpenChannelMessageList from './OpenChannelMessageList.js';
import '../../chunks/bundle-Dx_38OXn.js';
import '../../chunks/bundle-k5pprEL4.js';
import '../../chunks/bundle-DoyzmJ4N.js';
import '../../chunks/bundle-Dsv3ZewI.js';
import '../../chunks/bundle-D6tIALJA.js';
import '../../chunks/bundle-DlIBbbMW.js';
import '../../chunks/bundle-3CHYtOfL.js';
import '../../chunks/bundle-CAqNV7Jw.js';
import '@sendbird/chat';
import '@sendbird/chat/groupChannel';
import '@sendbird/chat/openChannel';
import '../../chunks/bundle-dMfcSy1Y.js';
import '../../chunks/bundle-Bv2JmaC2.js';
import '../../chunks/bundle-Dub55x6v.js';
import '../../chunks/bundle-3CVJzoCD.js';
import '../../chunks/bundle-BCC98_OB.js';
import '../../hooks/useModal.js';
import '../../chunks/bundle-CmS7TEQp.js';
import '../../chunks/bundle-Ds9YPch2.js';
import '../../chunks/bundle-EGZmMlDM.js';
import 'react-dom';
import '../../chunks/bundle-CDtkDyUw.js';
import '../../ui/IconButton.js';
import '../../ui/Button.js';
import '../../chunks/bundle-DHMhzdxb.js';
import '../../ui/Icon.js';
import '../../ui/MessageInput.js';
import '../../chunks/bundle-JgyblkJN.js';
import '../../chunks/bundle-CGpoAabY.js';
import '../../chunks/bundle-D13EwQ7_.js';
import 'dompurify';
import '../../chunks/bundle-T9VvSLxm.js';
import '../../chunks/bundle-Bx8Sqjji.js';
import '../../chunks/bundle-DIah6iEu.js';
import '../../chunks/bundle-BKsKPtjg.js';
import '../../utils/message/getOutgoingMessageState.js';
import '../../chunks/bundle-DTJNwlmx.js';
import '../../chunks/bundle-Dhfbe9sC.js';
import '../../chunks/bundle-CKuLtDzG.js';
import '../../chunks/bundle-DzLymkLP.js';
import '../../ui/ImageRenderer.js';
import '../../ui/Loader.js';
import '../../chunks/bundle-DOmw9Gpn.js';
import './OpenChannelMessage.js';
import '../../chunks/bundle-CUmaXfSc.js';
import '../../ui/OpenchannelUserMessage.js';
import '../../chunks/bundle-ACCb-8jH.js';
import '../../ui/SortByRow.js';
import '../../ui/UserProfile.js';
import '../../sendbirdSelectors.js';
import '../../chunks/bundle-DG90mvnD.js';
import '../../chunks/bundle-nXrIKErN.js';
import '../../chunks/bundle-CEq1fSuU.js';
import '../../ui/OpenChannelAdminMessage.js';
import '../../ui/OpenchannelOGMessage.js';
import '../../ui/LinkLabel.js';
import '../../chunks/bundle-DeDylv-S.js';
import '../../Message/context.js';
import '../../ui/MentionLabel.js';
import '../../ui/OpenchannelThumbnailMessage.js';
import '../../ui/OpenchannelFileMessage.js';
import '../../ui/TextButton.js';
import '../../chunks/bundle-C9Yf8_3z.js';
import '../../ui/DateSeparator.js';
import '../../ui/FileViewer.js';
import '../../chunks/bundle-CHc1MI8A.js';
import '@sendbird/uikit-tools';
import '../../chunks/bundle-DUX1Cjzd.js';
import '../../chunks/bundle-BZcIM6nq.js';
import '../../chunks/bundle-BAYOQ4lI.js';
import '../../chunks/bundle-SYD-r_6g.js';
import '@sendbird/chat/message';
import '../../Channel/utils/compareMessagesForGrouping.js';

var COMPONENT_CLASS_NAME = 'sendbird-openchannel-conversation';
var OpenChannelUI = function (_a) {
    var renderMessage = _a.renderMessage, renderHeader = _a.renderHeader, renderPlaceHolderEmptyList = _a.renderPlaceHolderEmptyList, renderPlaceHolderError = _a.renderPlaceHolderError, renderPlaceHolderLoading = _a.renderPlaceHolderLoading, renderMessageInput = _a.renderMessageInput, renderInput = _a.renderInput;
    var _b = useOpenChannelContext(), currentOpenChannel = _b.currentOpenChannel, amIBanned = _b.amIBanned, loading = _b.loading, isInvalid = _b.isInvalid, messageInputRef = _b.messageInputRef, conversationScrollRef = _b.conversationScrollRef;
    if (!currentOpenChannel
        || !(currentOpenChannel === null || currentOpenChannel === void 0 ? void 0 : currentOpenChannel.url)
        || amIBanned) {
        return ((renderPlaceHolderError === null || renderPlaceHolderError === void 0 ? void 0 : renderPlaceHolderError())
            || React__default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.createElement(PlaceHolder, { type: PlaceHolderTypes.NO_CHANNELS })));
    }
    if (loading) {
        return ((renderPlaceHolderLoading === null || renderPlaceHolderLoading === void 0 ? void 0 : renderPlaceHolderLoading())
            || React__default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.createElement(PlaceHolder, { type: PlaceHolderTypes.LOADING })));
    }
    if (isInvalid) {
        return ((renderPlaceHolderError === null || renderPlaceHolderError === void 0 ? void 0 : renderPlaceHolderError())
            || React__default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.createElement(PlaceHolder, { type: PlaceHolderTypes.WRONG })));
    }
    var renderInputComponent = renderMessageInput || renderInput;
    return (React__default.createElement("div", { className: COMPONENT_CLASS_NAME },
        (renderHeader === null || renderHeader === void 0 ? void 0 : renderHeader()) || React__default.createElement(OpenchannelConversationHeader, null),
        (currentOpenChannel === null || currentOpenChannel === void 0 ? void 0 : currentOpenChannel.isFrozen) && React__default.createElement(FrozenNotification, null),
        React__default.createElement(OpenChannelMessageList, { ref: conversationScrollRef, renderMessage: renderMessage, renderPlaceHolderEmptyList: renderPlaceHolderEmptyList }),
        (renderInputComponent === null || renderInputComponent === void 0 ? void 0 : renderInputComponent()) || React__default.createElement(OpenChannelInput, { ref: messageInputRef })));
};

export { OpenChannelUI as default };
//# sourceMappingURL=OpenChannelUI.js.map
