import { _ as __assign } from '../../chunks/bundle-k5pprEL4.js';
import React__default from 'react';
import ThreadListItem from './ThreadListItem.js';
import { compareMessagesForGrouping } from '../../Channel/utils/compareMessagesForGrouping.js';
import { isSameDay } from 'date-fns';
import { MessageProvider } from '../../Message/context.js';
import { g as getCaseResolvedReplyType } from '../../chunks/bundle-DqEFK1h_.js';
import { u as useThread } from '../../chunks/bundle-DiEyJmQO.js';
import { u as useSendbird } from '../../chunks/bundle-DlIBbbMW.js';
import { u as useLocalization } from '../../chunks/bundle-Dx_38OXn.js';
import '../../chunks/bundle-CUmaXfSc.js';
import '../../chunks/bundle-Dhfbe9sC.js';
import '../../chunks/bundle-Dsv3ZewI.js';
import '../../ui/DateSeparator.js';
import '../../chunks/bundle-C9Yf8_3z.js';
import '../../chunks/bundle-DHMhzdxb.js';
import '../../chunks/bundle-DoyzmJ4N.js';
import '../../chunks/bundle-BCO1ipEu.js';
import '../../chunks/bundle-EGZmMlDM.js';
import 'react-dom';
import '../../chunks/bundle-Ds9YPch2.js';
import '../../chunks/bundle-CDtkDyUw.js';
import '../../ui/IconButton.js';
import '../../ui/Button.js';
import '../../ui/Icon.js';
import '../../chunks/bundle-Dub55x6v.js';
import '../../chunks/bundle-DUX1Cjzd.js';
import '../../chunks/bundle-BKsKPtjg.js';
import '@sendbird/chat/groupChannel';
import '../../utils/message/getOutgoingMessageState.js';
import '../../chunks/bundle-DTJNwlmx.js';
import '../../chunks/bundle-CmS7TEQp.js';
import '../../chunks/bundle-CAqNV7Jw.js';
import '../../ui/FileViewer.js';
import '../../hooks/useModal.js';
import '../../chunks/bundle-3CHYtOfL.js';
import '@sendbird/chat';
import '@sendbird/chat/openChannel';
import '../../chunks/bundle-DzLymkLP.js';
import '../../ui/ImageRenderer.js';
import '../../chunks/bundle-BCC98_OB.js';
import '../../chunks/bundle-CHc1MI8A.js';
import '@sendbird/uikit-tools';
import '../../chunks/bundle-BOofcNOh.js';
import '../../chunks/bundle-Dd9BwqXA.js';
import '../../chunks/bundle-CGpoAabY.js';
import '../../chunks/bundle-JgyblkJN.js';
import '../../ui/MessageInput.js';
import '../../chunks/bundle-D13EwQ7_.js';
import 'dompurify';
import '../../chunks/bundle-T9VvSLxm.js';
import '../../chunks/bundle-Bx8Sqjji.js';
import '../../chunks/bundle-DIah6iEu.js';
import '../../chunks/bundle-CKuLtDzG.js';
import '../context/types.js';
import '../../chunks/bundle-ACCb-8jH.js';
import '../../ui/SortByRow.js';
import '../../ui/MessageItemReactionMenu.js';
import '../../ui/ReactionButton.js';
import '../../chunks/bundle-CEq1fSuU.js';
import '../../chunks/bundle-B6R3QLUf.js';
import '../../ui/Loader.js';
import '../../chunks/bundle-zMH_A6RI.js';
import '../../chunks/bundle-DOmw9Gpn.js';
import '../../ui/EmojiReactions.js';
import '../../ui/ReactionBadge.js';
import '../../ui/BottomSheet.js';
import '../../ui/UserListItem.js';
import '../../chunks/bundle-D6tIALJA.js';
import '../../ui/MutedAvatarOverlay.js';
import '../../ui/Checkbox.js';
import '../../ui/UserProfile.js';
import '../../sendbirdSelectors.js';
import '../../chunks/bundle-Bv2JmaC2.js';
import '../../ui/Tooltip.js';
import '../../ui/TooltipWrapper.js';
import '../../chunks/bundle-Cl49DqSv.js';
import '../../ui/MobileMenu.js';
import '../../chunks/bundle-Aco00fYQ.js';
import '@sendbird/chat/message';
import '../../chunks/bundle-BDhzQNdy.js';
import '../../chunks/bundle-CbWfQs4h.js';
import '../../chunks/bundle-C4olSBX9.js';
import '../../ui/OGMessageItemBody.js';
import '../../chunks/bundle-DeDylv-S.js';
import '../../ui/MentionLabel.js';
import '../../ui/LinkLabel.js';
import '../../ui/TextMessageItemBody.js';
import '../../ui/FileMessageItemBody.js';
import '../../ui/TextButton.js';
import '../../ui/VoiceMessageItemBody.js';
import '../../ui/ProgressBar.js';
import '../../VoicePlayer/useVoicePlayer.js';
import '../../chunks/bundle-Bu_CIwDm.js';
import '../../VoiceRecorder/context.js';
import '../../ui/PlaybackTime.js';
import '../../ui/ThumbnailMessageItemBody.js';
import '../../chunks/bundle-CtHkArHb.js';
import '../../ui/UnknownMessageItemBody.js';
import '../../ui/TemplateMessageItemBody.js';
import '../../chunks/bundle-CdFl8VL-.js';
import '../../ui/FallbackTemplateMessageItemBody.tsx.js';
import '../../ui/LoadingTemplateMessageItemBody.tsx.js';
import '../../ui/MessageFeedbackFailedModal.js';
import '../../chunks/bundle-DtNksMAv.js';
import '../../chunks/bundle-BTCLPh_U.js';
import '../../Message/hooks/useDirtyGetMentions.js';
import '../../chunks/bundle-BsU9k0LR.js';
import '../../chunks/bundle-SYD-r_6g.js';
import '../../chunks/bundle-dMfcSy1Y.js';
import '../../chunks/bundle-DKux8SCz.js';

function ThreadList(_a) {
    var className = _a.className, _b = _a.renderMessage, renderMessage = _b === void 0 ? function (props) { return React__default.createElement(ThreadListItem, __assign({}, props)); } : _b, renderCustomSeparator = _a.renderCustomSeparator, scrollRef = _a.scrollRef, scrollBottom = _a.scrollBottom;
    var config = useSendbird().state.config;
    var stringSet = useLocalization().stringSet;
    var userId = config.userId;
    var _c = useThread().state, currentChannel = _c.currentChannel, allThreadMessages = _c.allThreadMessages, localThreadMessages = _c.localThreadMessages;
    return (React__default.createElement("div", { className: "sendbird-thread-list ".concat(className) },
        allThreadMessages.map(function (message, idx) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var prevMessage = allThreadMessages[idx - 1];
            var nextMessage = allThreadMessages[idx + 1];
            // eslint-disable-next-line no-constant-condition
            var _b = compareMessagesForGrouping(prevMessage, message, nextMessage, stringSet, currentChannel, getCaseResolvedReplyType(config.groupChannel.replyType).upperCase)
                , chainTop = _b[0], chainBottom = _b[1];
            var hasSeparator = !((prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt) > 0 && (isSameDay(message === null || message === void 0 ? void 0 : message.createdAt, prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt)));
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current && scrollBottom) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.createElement(MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                chainTop: chainTop,
                chainBottom: chainBottom,
                hasSeparator: hasSeparator,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        }),
        localThreadMessages.map(function (message) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.createElement(MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                hasSeparator: false,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        })));
}

export { ThreadList as default };
//# sourceMappingURL=ThreadList.js.map
