'use strict';

var React = require('react');
var index$1 = require('../../chunks/bundle-C2HYdhmz.js');
var ui_Icon = require('../../ui/Icon.js');
var ui_PlaceHolder = require('../../ui/PlaceHolder.js');
var OpenChannel_context = require('../../chunks/bundle-BQozUdAi.js');
var OpenChannel_components_OpenChannelMessage = require('./OpenChannelMessage.js');
var Message_context = require('../../Message/context.js');
var index = require('../../chunks/bundle-Bc0FSDdg.js');
var Channel_utils_compareMessagesForGrouping = require('../../Channel/utils/compareMessagesForGrouping.js');
var useSendbird = require('../../chunks/bundle-CMlV_h38.js');
var LocalizationContext = require('../../chunks/bundle-O9GJGA-U.js');
require('../../chunks/bundle-CiHUpz7L.js');
require('../../chunks/bundle-3pIN38MR.js');
require('../../chunks/bundle-CJhoVxdz.js');
require('../../chunks/bundle-DONg2mag.js');
require('../../chunks/bundle-BRv5cK_w.js');
require('../../ui/Loader.js');
require('../../chunks/bundle-CIulWkOG.js');
require('../../chunks/bundle-C562G-JW.js');
require('../../chunks/bundle-CZLKAZCV.js');
require('../../chunks/bundle-C8f_4-N0.js');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-ByzBZitI.js');
require('../../chunks/bundle-wbXcvXS5.js');
require('../../chunks/bundle-XIN-6-ar.js');
require('../../hooks/useModal.js');
require('../../chunks/bundle-BnDEMyZ4.js');
require('../../chunks/bundle-DfzBeTAr.js');
require('react-dom');
require('../../chunks/bundle-DlPLN3bg.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('../../chunks/bundle-Sfn_RLlP.js');
require('../../chunks/bundle-CyENaxLd.js');
require('@sendbird/chat/groupChannel');
require('../../chunks/bundle-C596sNVY.js');
require('../../ui/OpenchannelUserMessage.js');
require('../../chunks/bundle-BikLdyZe.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-BbP1ND3d.js');
require('../../ui/SortByRow.js');
require('../../chunks/bundle-DrGYNNB5.js');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-BROd4sV1.js');
require('../../ui/UserProfile.js');
require('../../sendbirdSelectors.js');
require('../../chunks/bundle-CCW4ftK3.js');
require('../../chunks/bundle-CILnAeBz.js');
require('../../chunks/bundle-D1t8v8Qh.js');
require('../../ui/OpenChannelAdminMessage.js');
require('../../ui/OpenchannelOGMessage.js');
require('../../ui/LinkLabel.js');
require('../../chunks/bundle-C9sWmnis.js');
require('../../chunks/bundle-DZW3Wbi6.js');
require('../../ui/MentionLabel.js');
require('../../ui/OpenchannelThumbnailMessage.js');
require('../../ui/OpenchannelFileMessage.js');
require('../../ui/TextButton.js');
require('../../chunks/bundle-Bj-0Jsyi.js');
require('../../ui/DateSeparator.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-CvAcqCBF.js');
require('../../chunks/bundle-B5ykUWcV.js');
require('../../chunks/bundle-CMD6ZoBq.js');
require('dompurify');
require('../../chunks/bundle-Cc8WRa-f.js');
require('../../chunks/bundle-C_10r9lQ.js');
require('../../chunks/bundle-ADlxsvPE.js');
require('../../ui/FileViewer.js');
require('../../chunks/bundle-B-dq4NhE.js');
require('@sendbird/uikit-tools');
require('../../chunks/bundle-KtYdczLz.js');
require('../../chunks/bundle-BmFe2W3e.js');
require('../../chunks/bundle-ajPzzYnD.js');
require('@sendbird/chat/message');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

function OpenChannelMessageList(props, ref) {
    var _a = OpenChannel_context.useOpenChannelContext(), _b = _a.isMessageGroupingEnabled, isMessageGroupingEnabled = _b === void 0 ? true : _b, allMessages = _a.allMessages, hasMore = _a.hasMore, onScroll = _a.onScroll;
    var state = useSendbird.useSendbird().state;
    var stringSet = LocalizationContext.useLocalization().stringSet;
    var userId = state.config.userId;
    var localRef = React.useRef(null);
    var scrollRef = ref || localRef;
    var _c = React.useState(false), showScrollDownButton = _c[0], setShowScrollDownButton = _c[1];
    var scrollToBottom = function () {
        if (scrollRef && 'current' in scrollRef && scrollRef.current) {
            scrollRef.current.scrollTo(0, scrollRef.current.scrollHeight);
            setShowScrollDownButton(false);
        }
    };
    var handleOnScroll = index.useHandleOnScrollCallback({
        setShowScrollDownButton: setShowScrollDownButton,
        hasMore: hasMore,
        onScroll: onScroll,
        scrollRef: scrollRef,
    });
    var memoizedMessageList = React.useMemo(function () {
        var _a;
        if (allMessages.length > 0) {
            return (allMessages.map(function (message, index) {
                var _a;
                var previousMessage = allMessages[index - 1];
                var nextMessage = allMessages[index - 1];
                var previousMessageCreatedAt = previousMessage && previousMessage.createdAt;
                var currentCreatedAt = message === null || message === void 0 ? void 0 : message.createdAt;
                // https://stackoverflow.com/a/41855608
                var hasSeparator = !(previousMessageCreatedAt && (index$1.isSameDay(currentCreatedAt, previousMessageCreatedAt)));
                var _b = isMessageGroupingEnabled
                    ? Channel_utils_compareMessagesForGrouping.compareMessagesForGrouping(previousMessage, message, nextMessage, stringSet)
                    : [false, false], chainTop = _b[0], chainBottom = _b[1];
                var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
                var key = (message === null || message === void 0 ? void 0 : message.messageId) || (message === null || message === void 0 ? void 0 : message.reqId);
                return (React__default.default.createElement(Message_context.MessageProvider, { message: message, isByMe: isByMe, key: key },
                    React__default.default.createElement(OpenChannel_components_OpenChannelMessage, { message: message, chainTop: chainTop, chainBottom: chainBottom, hasSeparator: hasSeparator, renderMessage: props === null || props === void 0 ? void 0 : props.renderMessage })));
            }));
        }
        return (((_a = props === null || props === void 0 ? void 0 : props.renderPlaceHolderEmptyList) === null || _a === void 0 ? void 0 : _a.call(props)) || (React__default.default.createElement(ui_PlaceHolder.default, { className: "sendbird-openchannel-conversation-scroll__container__place-holder", type: ui_PlaceHolder.PlaceHolderTypes.NO_MESSAGES })));
    }, [allMessages]);
    return (React__default.default.createElement("div", { className: "sendbird-openchannel-conversation-scroll" },
        React__default.default.createElement("div", { className: "sendbird-openchannel-conversation-scroll__container" },
            React__default.default.createElement("div", { className: "sendbird-openchannel-conversation-scroll__container__padding" }),
            React__default.default.createElement("div", { className: [
                    'sendbird-openchannel-conversation-scroll__container__item-container',
                    (allMessages.length > 0) ? '' : 'no-messages',
                ].join(' '), onScroll: handleOnScroll, ref: scrollRef }, memoizedMessageList)),
        showScrollDownButton && (React__default.default.createElement("div", { className: "sendbird-openchannel-conversation-scroll__container__scroll-bottom-button", onClick: scrollToBottom, onKeyDown: scrollToBottom, tabIndex: 0, role: "button" },
            React__default.default.createElement(ui_Icon.default, { width: "24px", height: "24px", type: ui_Icon.IconTypes.CHEVRON_DOWN, fillColor: ui_Icon.IconColors.CONTENT })))));
}
var OpenChannelMessageList$1 = React__default.default.forwardRef(OpenChannelMessageList);

module.exports = OpenChannelMessageList$1;
//# sourceMappingURL=OpenChannelMessageList.js.map
