'use strict';

var React = require('react');
var OpenChannel_context = require('../../chunks/bundle-BQozUdAi.js');
var OpenChannel_components_OpenChannelInput = require('./OpenChannelInput.js');
var OpenChannel_components_FrozenChannelNotification = require('./FrozenChannelNotification.js');
var OpenChannel_components_OpenChannelHeader = require('./OpenChannelHeader.js');
var ui_PlaceHolder = require('../../ui/PlaceHolder.js');
var OpenChannel_components_OpenChannelMessageList = require('./OpenChannelMessageList.js');
require('../../chunks/bundle-O9GJGA-U.js');
require('../../chunks/bundle-3pIN38MR.js');
require('../../chunks/bundle-BRv5cK_w.js');
require('../../chunks/bundle-CIulWkOG.js');
require('../../chunks/bundle-C562G-JW.js');
require('../../chunks/bundle-CMlV_h38.js');
require('../../chunks/bundle-Sfn_RLlP.js');
require('../../chunks/bundle-CyENaxLd.js');
require('@sendbird/chat');
require('@sendbird/chat/groupChannel');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-CZLKAZCV.js');
require('../../chunks/bundle-C8f_4-N0.js');
require('../../chunks/bundle-ByzBZitI.js');
require('../../chunks/bundle-wbXcvXS5.js');
require('../../chunks/bundle-XIN-6-ar.js');
require('../../hooks/useModal.js');
require('../../chunks/bundle-BnDEMyZ4.js');
require('../../chunks/bundle-CJhoVxdz.js');
require('../../chunks/bundle-DfzBeTAr.js');
require('react-dom');
require('../../chunks/bundle-DlPLN3bg.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('../../chunks/bundle-DONg2mag.js');
require('../../ui/Icon.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-CvAcqCBF.js');
require('../../chunks/bundle-B5ykUWcV.js');
require('../../chunks/bundle-CMD6ZoBq.js');
require('dompurify');
require('../../chunks/bundle-Cc8WRa-f.js');
require('../../chunks/bundle-C_10r9lQ.js');
require('../../chunks/bundle-ADlxsvPE.js');
require('../../chunks/bundle-DrGYNNB5.js');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-BROd4sV1.js');
require('../../chunks/bundle-CiHUpz7L.js');
require('../../chunks/bundle-DZW3Wbi6.js');
require('../../chunks/bundle-BikLdyZe.js');
require('../../ui/ImageRenderer.js');
require('../../ui/Loader.js');
require('../../chunks/bundle-C2HYdhmz.js');
require('./OpenChannelMessage.js');
require('../../chunks/bundle-C596sNVY.js');
require('../../ui/OpenchannelUserMessage.js');
require('../../chunks/bundle-BbP1ND3d.js');
require('../../ui/SortByRow.js');
require('../../ui/UserProfile.js');
require('../../sendbirdSelectors.js');
require('../../chunks/bundle-CCW4ftK3.js');
require('../../chunks/bundle-CILnAeBz.js');
require('../../chunks/bundle-D1t8v8Qh.js');
require('../../ui/OpenChannelAdminMessage.js');
require('../../ui/OpenchannelOGMessage.js');
require('../../ui/LinkLabel.js');
require('../../chunks/bundle-C9sWmnis.js');
require('../../Message/context.js');
require('../../ui/MentionLabel.js');
require('../../ui/OpenchannelThumbnailMessage.js');
require('../../ui/OpenchannelFileMessage.js');
require('../../ui/TextButton.js');
require('../../chunks/bundle-Bj-0Jsyi.js');
require('../../ui/DateSeparator.js');
require('../../ui/FileViewer.js');
require('../../chunks/bundle-B-dq4NhE.js');
require('@sendbird/uikit-tools');
require('../../chunks/bundle-KtYdczLz.js');
require('../../chunks/bundle-Bc0FSDdg.js');
require('../../chunks/bundle-BmFe2W3e.js');
require('../../chunks/bundle-ajPzzYnD.js');
require('@sendbird/chat/message');
require('../../Channel/utils/compareMessagesForGrouping.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

var COMPONENT_CLASS_NAME = 'sendbird-openchannel-conversation';
var OpenChannelUI = function (_a) {
    var renderMessage = _a.renderMessage, renderHeader = _a.renderHeader, renderPlaceHolderEmptyList = _a.renderPlaceHolderEmptyList, renderPlaceHolderError = _a.renderPlaceHolderError, renderPlaceHolderLoading = _a.renderPlaceHolderLoading, renderMessageInput = _a.renderMessageInput, renderInput = _a.renderInput;
    var _b = OpenChannel_context.useOpenChannelContext(), currentOpenChannel = _b.currentOpenChannel, amIBanned = _b.amIBanned, loading = _b.loading, isInvalid = _b.isInvalid, messageInputRef = _b.messageInputRef, conversationScrollRef = _b.conversationScrollRef;
    if (!currentOpenChannel
        || !(currentOpenChannel === null || currentOpenChannel === void 0 ? void 0 : currentOpenChannel.url)
        || amIBanned) {
        return ((renderPlaceHolderError === null || renderPlaceHolderError === void 0 ? void 0 : renderPlaceHolderError())
            || React__default.default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.default.createElement(ui_PlaceHolder.default, { type: ui_PlaceHolder.PlaceHolderTypes.NO_CHANNELS })));
    }
    if (loading) {
        return ((renderPlaceHolderLoading === null || renderPlaceHolderLoading === void 0 ? void 0 : renderPlaceHolderLoading())
            || React__default.default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.default.createElement(ui_PlaceHolder.default, { type: ui_PlaceHolder.PlaceHolderTypes.LOADING })));
    }
    if (isInvalid) {
        return ((renderPlaceHolderError === null || renderPlaceHolderError === void 0 ? void 0 : renderPlaceHolderError())
            || React__default.default.createElement("div", { className: COMPONENT_CLASS_NAME },
                React__default.default.createElement(ui_PlaceHolder.default, { type: ui_PlaceHolder.PlaceHolderTypes.WRONG })));
    }
    var renderInputComponent = renderMessageInput || renderInput;
    return (React__default.default.createElement("div", { className: COMPONENT_CLASS_NAME },
        (renderHeader === null || renderHeader === void 0 ? void 0 : renderHeader()) || React__default.default.createElement(OpenChannel_components_OpenChannelHeader, null),
        (currentOpenChannel === null || currentOpenChannel === void 0 ? void 0 : currentOpenChannel.isFrozen) && React__default.default.createElement(OpenChannel_components_FrozenChannelNotification, null),
        React__default.default.createElement(OpenChannel_components_OpenChannelMessageList, { ref: conversationScrollRef, renderMessage: renderMessage, renderPlaceHolderEmptyList: renderPlaceHolderEmptyList }),
        (renderInputComponent === null || renderInputComponent === void 0 ? void 0 : renderInputComponent()) || React__default.default.createElement(OpenChannel_components_OpenChannelInput, { ref: messageInputRef })));
};

module.exports = OpenChannelUI;
//# sourceMappingURL=OpenChannelUI.js.map
