'use strict';

var _tslib = require('../../chunks/bundle-3pIN38MR.js');
var React = require('react');
var Thread_components_ThreadListItem = require('./ThreadListItem.js');
var Channel_utils_compareMessagesForGrouping = require('../../Channel/utils/compareMessagesForGrouping.js');
var dateFns = require('date-fns');
var Message_context = require('../../Message/context.js');
var resolvedReplyType = require('../../chunks/bundle-CfoP-Q6S.js');
var ThreadProvider = require('../../chunks/bundle-CSR_gGWO.js');
var useSendbird = require('../../chunks/bundle-CMlV_h38.js');
var LocalizationContext = require('../../chunks/bundle-O9GJGA-U.js');
require('../../chunks/bundle-C596sNVY.js');
require('../../chunks/bundle-CiHUpz7L.js');
require('../../chunks/bundle-CIulWkOG.js');
require('../../ui/DateSeparator.js');
require('../../chunks/bundle-Bj-0Jsyi.js');
require('../../chunks/bundle-DONg2mag.js');
require('../../chunks/bundle-BRv5cK_w.js');
require('../../chunks/bundle-Bj_ZknNa.js');
require('../../chunks/bundle-DfzBeTAr.js');
require('react-dom');
require('../../chunks/bundle-CJhoVxdz.js');
require('../../chunks/bundle-DlPLN3bg.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('../../ui/Icon.js');
require('../../chunks/bundle-ByzBZitI.js');
require('../../chunks/bundle-KtYdczLz.js');
require('../../chunks/bundle-DrGYNNB5.js');
require('@sendbird/chat/groupChannel');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-BROd4sV1.js');
require('../../chunks/bundle-BnDEMyZ4.js');
require('../../chunks/bundle-CyENaxLd.js');
require('../../ui/FileViewer.js');
require('../../hooks/useModal.js');
require('../../chunks/bundle-Sfn_RLlP.js');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-BikLdyZe.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-XIN-6-ar.js');
require('../../chunks/bundle-B-dq4NhE.js');
require('@sendbird/uikit-tools');
require('../../chunks/bundle-Dc_jkavG.js');
require('../../chunks/bundle-CXEoZwsy.js');
require('../../chunks/bundle-B5ykUWcV.js');
require('../../chunks/bundle-CvAcqCBF.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-CMD6ZoBq.js');
require('dompurify');
require('../../chunks/bundle-Cc8WRa-f.js');
require('../../chunks/bundle-C_10r9lQ.js');
require('../../chunks/bundle-ADlxsvPE.js');
require('../../chunks/bundle-DZW3Wbi6.js');
require('../context/types.js');
require('../../chunks/bundle-BbP1ND3d.js');
require('../../ui/SortByRow.js');
require('../../ui/MessageItemReactionMenu.js');
require('../../ui/ReactionButton.js');
require('../../chunks/bundle-D1t8v8Qh.js');
require('../../chunks/bundle-BL4JFX3Z.js');
require('../../ui/Loader.js');
require('../../chunks/bundle-tJJa3vGc.js');
require('../../chunks/bundle-C2HYdhmz.js');
require('../../ui/EmojiReactions.js');
require('../../ui/ReactionBadge.js');
require('../../ui/BottomSheet.js');
require('../../ui/UserListItem.js');
require('../../chunks/bundle-C562G-JW.js');
require('../../ui/MutedAvatarOverlay.js');
require('../../ui/Checkbox.js');
require('../../ui/UserProfile.js');
require('../../sendbirdSelectors.js');
require('../../chunks/bundle-C8f_4-N0.js');
require('../../ui/Tooltip.js');
require('../../ui/TooltipWrapper.js');
require('../../chunks/bundle-CZ9J_2gz.js');
require('../../ui/MobileMenu.js');
require('../../chunks/bundle-CItVMA2G.js');
require('@sendbird/chat/message');
require('../../chunks/bundle-DnOhDHp5.js');
require('../../chunks/bundle-CdMrvui6.js');
require('../../chunks/bundle-C6W6XKUm.js');
require('../../ui/OGMessageItemBody.js');
require('../../chunks/bundle-C9sWmnis.js');
require('../../ui/MentionLabel.js');
require('../../ui/LinkLabel.js');
require('../../ui/TextMessageItemBody.js');
require('../../ui/FileMessageItemBody.js');
require('../../ui/TextButton.js');
require('../../ui/VoiceMessageItemBody.js');
require('../../ui/ProgressBar.js');
require('../../VoicePlayer/useVoicePlayer.js');
require('../../chunks/bundle-ChahVmSf.js');
require('../../VoiceRecorder/context.js');
require('../../ui/PlaybackTime.js');
require('../../ui/ThumbnailMessageItemBody.js');
require('../../chunks/bundle-ByGirtv0.js');
require('../../ui/UnknownMessageItemBody.js');
require('../../ui/TemplateMessageItemBody.js');
require('../../chunks/bundle-CfXO3dEz.js');
require('../../ui/FallbackTemplateMessageItemBody.tsx.js');
require('../../ui/LoadingTemplateMessageItemBody.tsx.js');
require('../../ui/MessageFeedbackFailedModal.js');
require('../../chunks/bundle-Cz2GZ925.js');
require('../../chunks/bundle-DdoxXpVR.js');
require('../../Message/hooks/useDirtyGetMentions.js');
require('../../chunks/bundle-C19uVjCa.js');
require('../../chunks/bundle-ajPzzYnD.js');
require('../../chunks/bundle-CZLKAZCV.js');
require('../../chunks/bundle-CZimBvba.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

function ThreadList(_a) {
    var className = _a.className, _b = _a.renderMessage, renderMessage = _b === void 0 ? function (props) { return React__default.default.createElement(Thread_components_ThreadListItem, _tslib.__assign({}, props)); } : _b, renderCustomSeparator = _a.renderCustomSeparator, scrollRef = _a.scrollRef, scrollBottom = _a.scrollBottom;
    var config = useSendbird.useSendbird().state.config;
    var stringSet = LocalizationContext.useLocalization().stringSet;
    var userId = config.userId;
    var _c = ThreadProvider.useThread().state, currentChannel = _c.currentChannel, allThreadMessages = _c.allThreadMessages, localThreadMessages = _c.localThreadMessages;
    return (React__default.default.createElement("div", { className: "sendbird-thread-list ".concat(className) },
        allThreadMessages.map(function (message, idx) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var prevMessage = allThreadMessages[idx - 1];
            var nextMessage = allThreadMessages[idx + 1];
            // eslint-disable-next-line no-constant-condition
            var _b = Channel_utils_compareMessagesForGrouping.compareMessagesForGrouping(prevMessage, message, nextMessage, stringSet, currentChannel, resolvedReplyType.getCaseResolvedReplyType(config.groupChannel.replyType).upperCase)
                , chainTop = _b[0], chainBottom = _b[1];
            var hasSeparator = !((prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt) > 0 && (dateFns.isSameDay(message === null || message === void 0 ? void 0 : message.createdAt, prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt)));
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current && scrollBottom) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.default.createElement(Message_context.MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                chainTop: chainTop,
                chainBottom: chainBottom,
                hasSeparator: hasSeparator,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        }),
        localThreadMessages.map(function (message) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.default.createElement(Message_context.MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                hasSeparator: false,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        })));
}

module.exports = ThreadList;
//# sourceMappingURL=ThreadList.js.map
